# SPIM S20 MIPS simulator.
# A test of memory mapped I/O on the Spim simulator.
# Copyright (C) 1992 Scott Kempf, socttk@cs.wisc.edu
#
# SPIM is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 1, or (at your option) any
# later version.
#
# SPIM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU CC; see the file COPYING.
#
    			# Assign addresses to labels
	.eq	KeyboardData	0xffff0004
	.eq	KeyboardStatus	0xffff0000
	.eq	DisplayData	0xffff000c
	.eq	DisplayStatus	0xffff0008
	.eq	KeyboardData2	0xffff0014
	.eq	KeyboardStatus2	0xffff0010
	.eq	DisplayData2	0xffff001c
	.eq	DisplayStatus2	0xffff0018
	.eq	ClockStatus	0xffff0020

	.ktext
	.space	0x80		# Skip space so kernel starts at 0x80000080
	mfc0	$k0 $12
	and	$k0 0xffff00ff	# Turn off interrupts
	mtc0	$k0 $12
        beq     $k1 $0 expected
        la      $k1 fail
        rfe
        j       $k1

expected:
        mfc0    $k0 $13
        and     $k0 $k0 0xff
        sra     $k0 $k0 2       # $k0 holds ExcCode
        bne     $k0 $0 not_interrupt

        mfc0    $k1 $13
        and     $k1 $k1 0xfffffcff      # Clear software interrupts.
        mtc0    $k1 $13

not_interrupt:
        mfc0    $k1 $14
        add     $k1 $k1 4       # $k1 holds EPC + 4
        rfe
        j       $k1

	.data
fm:	.asciiz "Failed test\n"
	.text
fail:	la $4, fm
	jal PrintString
	li $2, 13
	syscall

PrintString:			# It is used only to print errors.
	lb	$6, ($4)
	beqz	$6, PSCont
PSLoop:	lw	$5, DisplayStatus
        andi    $5, $5, 0x01    # check READY bit
	beq	$5, $0, PSLoop
	sw	$6, DisplayData
	add	$4, $4, 1
	j	PrintString
PSCont:	j	$31

	.text
	.globl __start
__start:
	li $k1 0	# Allow for start-up interrupts
	li $k1 0	# Allow for start-up interrupts
	li $k1 0	# Allow for start-up interrupts
	li $k1 1

	.data
sysmess:.asciiz "Testing syscall\n"
	.text
	la $4 sysmess
	jal PrintString
	li $k1 0
	syscall
sysret: la $3 sysret
	bne $k1 $3 fail
	bne $k0 8 fail

	.data
pm:	.asciiz "All tests passed.\n"
	.text
	la $4 pm
	jal PrintString
	li $2, 13
	syscall
